# pyAB_prj.py

from tkinter import *
import tkinter as ttk
import serial
import threading
import queue
import time
import datetime

# This is hard coded COM port and BAUD.
ser = serial.Serial('COM8:',9600)
# This would be for Linux
#ser = serial.Serial(port='/dev/ttyUSB0',baudrate=9600)

def goodbye(*args):
	ser.close()  # Closes the serial port, very important.
	quit()  # Stops the program and closes the window.
def go_fore(*args):
	out_data = b'gofore\n'
	ser.write(out_data)
	
def go_back(*args):
	out_data = b'goback\n'
	ser.write(out_data)
	
def stop_bot(*args):
	out_data = b'gostop\n'
	ser.write(out_data)
	
def go_left(*args):
	out_data = b'goleft\n'
	ser.write(out_data)
	
def go_rite(*args):
	out_data = b'goright\n'
	ser.write(out_data)
	
def start_roam(*args):
	out_data = b'startroam\n'
	ser.write(out_data)
	
def stop_roam(*args):
	out_data = b'stoproam\n'
	ser.write(out_data)

def on_led(*args):
	out_data = b'onled\n'
	ser.write(out_data)

def off_led(*args):
	out_data = b'offled\n'
	ser.write(out_data)

# Load and upload a scipt file.
def run_script(*args):
# Signal ActivityBot to start script interpreter.	
	out_data = b'runprog\n'
	ser.write(out_data)
	time.sleep(0.5)
# Open the hard coded text file.
	trun=open("progrun.txt",'r')
# Start the file read loop.
	while 1:
		line = trun.readline() # Get a line
		if not line:
			break
		#print(line)  # If you want to see the on std terminal.
# Send it to the AcitivityBot		
		ser.write(bytearray(line,'ascii'))
		#ser.write(b"\n")  # ActivityBot readStr() coommand needs this.
# I/O buffering
		while True:
			time.sleep(0.5)
			if ser.inWaiting():
				text = ser.readline(ser.inWaiting())
				if text == b'#':  # I/O buffer device.
					break
			break  # Break out of the 'while True' loop to continue.
# When script file reaches '::' close file and finish loop.
	#out_data = b'::\n'
	#ser.write(out_data)
	trun.close()  # Close the file.	

# This will run the Serial aware job as a background job.
class SerialThread(threading.Thread):
	def __init__(self, queue):
		threading.Thread.__init__(self)
		self.queue = queue
	def run(self):
		while True:
			if ser.inWaiting():
				text = ser.readline(ser.inWaiting())
				print(text)
				#f.write(text.decode("utf-8"))  # Log the button press
				#time.sleep(0.1)
				#if text == b'logtime':	# Check to see if PopBOE sent log data request.				
					# Example of how to write a variable that contains
					# a string to the serial out.
					#f.write(text.decode("utf-8"))
					# Write the timestamp to log file.
					#f.write(now.strftime(b" %m-%d-%y %H:%M:%S\n".decode("utf-8")))

			now = datetime.datetime.now() # Timedate update


class App(ttk.Tk):
	def __init__(self):
		ttk.Tk.__init__(self)
		self.geometry("400x300")  # Main window size
		self.wm_title("ActivityBot Control Program")  # Main window title
# Create the buttons and place them in the window.
# Quit the program		
		ttk.Button(self,text="Quit", command=goodbye).grid(column=1,row=1)
# Move bot forward
		ttk.Button(self,text="Forward", command=go_fore).grid(column=2,row=2)
# Stop the bot
		ttk.Button(self,text="Stop", command=stop_bot).grid(column=2,row=3)
# Move bot backward
		ttk.Button(self,text="Backward", command=go_back).grid(column=2,row=4)
# Turn bot left
		ttk.Button(self,text="Left", command=go_left).grid(column=1,row=3)
# Turn bot right
		ttk.Button(self,text="Right", command=go_rite).grid(column=3,row=3)
# Start roaming
		ttk.Button(self,text="Start Roam", command=start_roam).grid(column=1,row=5)
# Stop roaming	
		ttk.Button(self,text="Stop Roam", command=stop_roam).grid(column=3,row=5)
# Turn on LED
		ttk.Button(self,text="On LED", command=on_led).grid(column=1,row=6)
# Turn off LED
		ttk.Button(self,text="Off LED", command=off_led).grid(column=3,row=6)
# Feed a script to ActivityBot
		ttk.Button(self,text="Run Script", command=run_script).grid(column=1,row=7)

# Start the Serial thread.
		thread = SerialThread(self)
		thread.start()


# Application startup
app = App()
app.mainloop()
